//## begin module.cm preserve=no
//	  %X% %Q% %Z% %W%
//## end module.cm

//## begin module.cp preserve=no
//## end module.cp

//## Module: Graph; Package specification
//## Subsystem: Graphics
//## Source file: D:\Computao_Grfica\opengl_prog\showgeo\Graphics\Graph.h


#ifndef Graph_h
#define Graph_h 1

//## begin module.additionalIncludes preserve=no
//## end module.additionalIncludes

//## begin module.includes preserve=yes
//## end module.includes

// DefSegList
#include "MyLists\DfSgList.h"
// DefElementList
#include "MyLists\DflmntLs.h"
// DefNodeList
#include "MyLists\DfNdList.h"
// Node
#include "Nodes\Node.h"

class Dictionary;

//## begin module.declarations preserve=no
//## end module.declarations

//## begin module.additionalDeclarations preserve=yes
//## end module.additionalDeclarations


//## Class: Graph
//## Category: Graphics
//## Subsystem: Graphics
//## Persistence: Transient
//## Cardinality/Multiplicity: n

//## Uses: <unnamed>; Dictionary { -> F}

class Graph 
{
  //## begin Graph.initialDeclarations preserve=yes
  //## end Graph.initialDeclarations

  public:
    //## Constructors (generated)
      Graph();


    //## Other Operations (specified)
      //## Operation: give_All_Attributes_List%1047945987
      void give_All_Attributes_List(Graph& theGraph, char str[80]);

      //## Operation: give_Draw_Polygon%1048180252
      void give_Draw_Polygon(double deep, long int list_dim, Graph& theGraph);

      //## Operation: give_Draw_Side_Polygon%1049730929
      void give_Draw_Side_Polygon(long int list_size, double z_value, Graph& theGraph);

      //## Operation: give_Show_Mesh%1055720530
      void give_Show_Mesh(Graph& theGraph);

    //## Get and Set Operations for Class Attributes (generated)

      //## Attribute: theNodeList
      NodeList get_theNodeList();
      void set_theNodeList(const NodeList value);

      //## Attribute: theSegmentList
      SegmentList get_theSegmentList();
      void set_theSegmentList(const SegmentList value);

      //## Attribute: theElementList
      ElementList get_theElementList();
      void set_theElementList(const ElementList value);

      //## Attribute: numberofnodes
      long int get_numberofnodes();
      void set_numberofnodes(const long int value);

      //## Attribute: numberofelements
      long int get_numberofelements();
      void set_numberofelements(const long int value);

      //## Attribute: numberofsegments
      long int get_numberofsegments();
      void set_numberofsegments(const long int value);

    // Additional Public Declarations
      //## begin Graph.public preserve=yes
      //## end Graph.public


  protected:
    // Additional Protected Declarations
      //## begin Graph.protected preserve=yes
      //## end Graph.protected


  private:
    // Additional Private Declarations
      //## begin Graph.private preserve=yes
      //## end Graph.private


  private:  //## implementation
    // Data Members for Class Attributes

      //## begin Graph::theNodeList.attr preserve=no  public: NodeList {U} 
      NodeList theNodeList;
      //## end Graph::theNodeList.attr

      //## begin Graph::theSegmentList.attr preserve=no  public: SegmentList {U} 
      SegmentList theSegmentList;
      //## end Graph::theSegmentList.attr

      //## begin Graph::theElementList.attr preserve=no  public: ElementList {U} 
      ElementList theElementList;
      //## end Graph::theElementList.attr

      //## begin Graph::numberofnodes.attr preserve=no  public: long int {U} 0
      long int numberofnodes;
      //## end Graph::numberofnodes.attr

      //## begin Graph::numberofelements.attr preserve=no  public: long int {U} 0
      long int numberofelements;
      //## end Graph::numberofelements.attr

      //## begin Graph::numberofsegments.attr preserve=no  public: long int {U} 0
      long int numberofsegments;
      //## end Graph::numberofsegments.attr

    // Additional Implementation Declarations
      //## begin Graph.implementation preserve=yes
      //## end Graph.implementation

};



// Class Graph 

//## Get and Set Operations for Class Attributes (inline)

inline NodeList Graph::get_theNodeList()
{
  //## begin Graph::get_theNodeList%.get preserve=no
  return theNodeList;
  //## end Graph::get_theNodeList%.get
}

inline void Graph::set_theNodeList(const NodeList value)
{
  //## begin Graph::set_theNodeList%.set preserve=no
  theNodeList = value;
  //## end Graph::set_theNodeList%.set
}

inline SegmentList Graph::get_theSegmentList()
{
  //## begin Graph::get_theSegmentList%.get preserve=no
  return theSegmentList;
  //## end Graph::get_theSegmentList%.get
}

inline void Graph::set_theSegmentList(const SegmentList value)
{
  //## begin Graph::set_theSegmentList%.set preserve=no
  theSegmentList = value;
  //## end Graph::set_theSegmentList%.set
}

inline ElementList Graph::get_theElementList()
{
  //## begin Graph::get_theElementList%.get preserve=no
  return theElementList;
  //## end Graph::get_theElementList%.get
}

inline void Graph::set_theElementList(const ElementList value)
{
  //## begin Graph::set_theElementList%.set preserve=no
  theElementList = value;
  //## end Graph::set_theElementList%.set
}

inline long int Graph::get_numberofnodes()
{
  //## begin Graph::get_numberofnodes%.get preserve=no
  return numberofnodes;
  //## end Graph::get_numberofnodes%.get
}

inline void Graph::set_numberofnodes(const long int value)
{
  //## begin Graph::set_numberofnodes%.set preserve=no
  numberofnodes = value;
  //## end Graph::set_numberofnodes%.set
}

inline long int Graph::get_numberofelements()
{
  //## begin Graph::get_numberofelements%.get preserve=no
  return numberofelements;
  //## end Graph::get_numberofelements%.get
}

inline void Graph::set_numberofelements(const long int value)
{
  //## begin Graph::set_numberofelements%.set preserve=no
  numberofelements = value;
  //## end Graph::set_numberofelements%.set
}

inline long int Graph::get_numberofsegments()
{
  //## begin Graph::get_numberofsegments%.get preserve=no
  return numberofsegments;
  //## end Graph::get_numberofsegments%.get
}

inline void Graph::set_numberofsegments(const long int value)
{
  //## begin Graph::set_numberofsegments%.set preserve=no
  numberofsegments = value;
  //## end Graph::set_numberofsegments%.set
}





#endif


